<?php
// tòmò web analytics
// Copyright since 2011 by Yves Goergen
// Website: http://unclassified.de/go/tomo
// Licence: GNU General Public License (GPL) Version 3
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)

##skip
if (true)
{
	// Code for source files execution (development)
	require_once 'lib/environment.class.php';
	require_once 'lib/configuration.class.php';
	require_once 'lib/database.class.php';
	require_once 'lib/debug.class.php';
	require_once 'lib/geoip.class.php';
	require_once 'lib/publicsuffix.class.php';
	require_once 'lib/tomo.class.php';
	require_once 'lib/contenttype.class.php';
	require_once 'lib/locale.class.php';
	require_once 'lib/global.lib.php';
	require_once 'lib/ui.lib.php';
	require_once 'lib/viewer.class.php';

	UnbConfiguration::SetFilename('../config.inc.php');
	GeoIP::SetDBFileName('../../geoip/');
	#SetImgPath('../img/');   // Currently ignored (see ui.lib.php)
	TomoViewer::$queriesPath = '../queries/';
}
else
{
##endskip
	// Code for compiled files execution (release)
	$geoIpPath = UnbConfiguration::Get('geoip.path', '');
	if (strlen($geoIpPath))
		GeoIP::SetDBFileName($geoIpPath);

	TomoViewer::$queriesPath = UnbConfiguration::Get('queries.path', 'queries/');
	if (substr(TomoViewer::$queriesPath, -1) != '/')
		TomoViewer::$queriesPath .= '/';
##skip
}
##endskip

if (UnbConfiguration::Get('debug.log', false))
{
	UnbDatabase::GetInstance()->SetDisplayQueryErrors(true);
	UnbDebug::SetTraceToFile(true);
}

if ($_GET['post'] == '1' ||
	$_GET['imgns'] == '1')
{
	#if ($_GET['post'] == '1' && !$_POST['at']) sleep(2);   // TEST DEBUG TODO
	
	Tomo::FixParsePostData();

	UnbEnvironment::SetupEnvironment();
	UnbDatabase::GetInstance()->Open();

	$tomo = new Tomo();

	if (UnbConfiguration::Get('debug.log', false))
	{
		$tomo->SetWritePostLog(true);
	}

	$tomo->HandlePostRequest();
}
else if (strlen($_GET['view']))
{
	TomoViewer::Start();
}
else if (!UnbEnvironment::IsWebRequest())
{
	TomoViewer::LocalExec();
}
else
{
	// Serve JavaScript file
	header('Content-Type: application/javascript');
	if (UnbConfiguration::Get('debug.jsnocache', false))
	{
		header('Pragma: no-cache');
		header('Cache-Control: no-cache');
		header('Expires: 0');
	}
	else
	{
		header('Expires: ' . date('r', time() + 900));   // 15 minutes
	}
	UnbEnvironment::EnableHttpCompression();

	readfile('tomo.js');
}
?>
